/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : PPE Robot(s)
Version : 1
Date    : 05/07/2009
Author  : MNO                             
Company : Lyce Pierre Emile Martin 18000 BOURGES                                
Comments: Mise en oeuvre du protocole I2C sur l'interface TWI
Transfert de l'tat des BP sur les LEDs de la carte (PCF8574)
Adaptation de la note d'application AVR315 d'ATMEL

Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <mega8535.h>
#include <delay.h>  

#include "TWI_F.c" // Fonctions du drivers TWI adaptes pour CVAVR


// ----------------------------------------------------------------------------------------------------------
// Boucle principale
// ----------------------------------------------------------------------------------------------------------
void main(void)
{
// Declare your local variables here
unsigned char messageLEDOn[]={0x40,0x00}; 	// {addLed out, data = all Led on}
unsigned char messageLEDOff[]={0x40,0xff}; 	// {addLed out, data = all Led off}
unsigned char messageBP[]={0x43,0x00}; 		// {addBP out, data=nothing}
unsigned char DonneeBP[]={0xff,0x00};		// {addBP in, data=nothing}

TWI_Master_Initialise(); 	// Initialisation de l'interface TWI en mode Standby

// Global enable interrupts
#asm("sei")

TWI_Start_Transc_With_Data(messageLEDOff,2);  //

while (1)
      {
        TWI_Start_Transc_With_Data(messageBP,1);  	// Envoi octet d'adresse des BP + bit RW=lecture(0x43)
        TWI_Get_Data_From_Transceiver(DonneeBP, 2 );  	// Lecture du buffer (octet1=add, octet2=donnee etat BP)
        messageLEDOn[1]=~DonneeBP[1];                  	// Transfert etat BP dans message LED On
        TWI_Start_Transc_With_Data(messageLEDOn,2); 	// Commande des LED
        delay_ms(200);
	/*TWI_Start_Transc_With_Data(messageLEDOff,2);
	delay_ms(200);      */
      };
}

